=== debian/changelog ===
calamares (3.3.0~git20220608-0ubuntu1) kinetic; urgency=medium

  * New upstream snapshot.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Wed, 08 Jun 2022 18:43:01 -0500
